#!/bin/sh
#
# Parser script for a cross-platform (CP) upgrade

# List of parameters to parse and reserve
para_list="
multicast_address
multicast_port
multicast_ttl
VidStd
program_name
blackDuration
pictureNoiseLevel
freezeDuration
audioOverLevel
audioOverDuration
audioSilenceLevel
audioSilenceDuration
videoErrorDuration
faultConditionDuration
faultConditionLogic
trapsNotify
trapTag
sendTrap_videoMissing
sendTrap_audioMissing
sendTrap_pictureFreeze
sendTrap_pictureBlack
sendTrap_audioOver
sendTrap_audioSilence
resized_width
resized_height
ntp_server_address
enable_ntpdate
"

#File name
in_cfg_file="/tmp/vid_enc_cfg_720x480.txt"
encoder_cfg_file="/mnt/flashdisk/vid_enc_cfg_720x480.txt"
out_cfg_file="./cfg_back"
temp_file="/tmp/temp_cfg"

#Usage: parse_and_replace str_to_search 
parse_and_replace(){

    if [ -z "$1" ]; then                       # Is parameter #1 zero length?
      echo "-Parameter #1 is zero length"  # Or no parameter passed.
      return 1
    fi

	in_para_val=`grep "$1.*=.*"  $encoder_cfg_file | cut -d "=" -f 2 | cut -d "#" -f 1`
	if [ -z $in_para_val ]; then
	   echo "$1 Not Exist in file $encoder_cfg_file"
	   return 2
	else
	   new_para_name=`grep "$1.*=.*"  $in_cfg_file | cut -d "=" -f 1`
	   new_para_comment=`grep "$1.*=.*"  $in_cfg_file | cut -d "#" -f 2`
	   has_comment=`grep "$1.*=.*"  $in_cfg_file | grep \#`
	   if [ -z "$has_comment" ]; then
		   new_para="$new_para_name=$in_para_val" #Consist of 2 parts, no comments
	   else
		   new_para="$new_para_name=$in_para_val#$new_para_comment" #Consist of 3 parts
	   fi
#	   echo "new_para is [$new_para]"
	   sed "s/$1.*=.*/$new_para/g" $out_cfg_file  > $temp_file
	   cp $temp_file $out_cfg_file
	fi
	return 0
} 
 
if [ ! -f $in_cfg_file ]; then
	echo "Can't find file [$in_cfg_file], exit. "
	exit 1
fi

if [ ! -f $encoder_cfg_file ]; then
	echo "Can't find file [$encoder_cfg_file], exit. "
	exit 1
fi

#Get a temp copy of $in_cfg_file
cp $in_cfg_file $out_cfg_file

#parse and replace
for para in $para_list
do
	parse_and_replace $para
done
  
cp $out_cfg_file $encoder_cfg_file
rm -f $in_cfg_file $out_cfg_file $temp_file
exit 0
