#!/bin/sh
#
#This is for SLKE
#
#image file1 name
img1=uImage
#Dev to write this image to:
dev1=/dev/mtd2

#image file2 name
img2=enc_bp.ramdisk32m.gz
#Dev to write this image to:
dev2=/dev/mtd3

#Function to delete img files
rm_files() {
	rm -f $img1
	rm -f $img2
}

#Function to call if fails
fail() {
	rm_files
	echo "upgrade: $1"
	exit 1
}

#Write the image
echo "Do firmware updating ..."
	
/ali/eraseall -q $dev1 || fail "error: flash_eraseall $dev1 failed."
/ali/nandwrite -p -q $dev1 $img1 || fail "error: nandwrite $dev1 $img1 failed."
echo "writing $img1 OK"
	
/ali/eraseall -q $dev2 || fail "error: flash_eraseall $dev2 failed."
/ali/nandwrite -p -q $dev2 $img2 || fail "error: nandwrite $dev2 $img2 failed."
echo "writing $img2 OK"

# Kam: To detect cross-platform and version upgrade for SLKE 
#aboutTo=`grep "platform" ./vid_enc_cfg_720x480.txt | cut -d "=" -f 2 | cut -d " " -f 2`
aboutTo=`grep "platform" ./vid_enc_cfg_720x480.txt | cut -d "=" -f 2 | cut -d " " -f 2 | cut -d " " -f 1 | cut -d "^" -f 1`

#actual=`grep "platform" /mnt/flashdisk/vid_enc_cfg_720x480.txt | cut -d "=" -f 2 | cut -d " " -f 2`
actual=`grep "platform"  /mnt/flashdisk/vid_enc_cfg_720x480.txt | cut -d "=" -f 2 | cut -d " " -f 2 | cut -d " " -f 1 | cut -d "^" -f 1`

aboutToFirmare=`grep "firmware_version" ./vid_enc_cfg_720x480.txt | cut -d "=" -f 2 | cut -d " " -f 2 | cut -d " " -f 1 | cut -d "^" -f 1`
actualFirmare=`grep "firmware_version"  /mnt/flashdisk/vid_enc_cfg_720x480.txt | cut -d "=" -f 2 | cut -d " " -f 2 | cut -d " " -f 1 | cut -d "^" -f 1`

echo $actual: $aboutToFirmare
echo $aboutTo: $actualFirmare
fw_setenv_file=/ali/fw_setenv

if [ "$actual" != "$aboutTo" ]; then
	echo "========== SLKE: Cross-Platform Upgrade...! (User-defined configuration will be restored) =========="
	echo "kjarrah@evertz.com: To parse the configuration file..."
	./encoder_cfg_parser_cp.sh					# Parse /tmp/cfg_forward back into /mnt/flashdisk/vid_enc_cfg_720x480.txt
    rm -f /tmp/encoder_cfg_parser_cp.sh /tmp/encoder_cfg_parser_vu.sh
	chmod 666 /mnt/flashdisk/vid_enc_cfg_720x480.txt

    if [ ! -f $fw_setenv_file ]; then
		echo "kjarrah@evertz.com: To set fw environment..."
                mv /tmp/fw_setenv /ali/fw_setenv
                mv /tmp/fw_env.config /etc
                chmod 755 /ali/fw_setenv
	else
		rm -f /tmp/fw_setenv
		rm -f /tmp/fw_env.config
    fi

	echo "kjarrah@evertz.com: To switch to the non-standard mode..."
	/ali/fw_setenv bootargs 'setenv bootargs console=ttyS0,115200n8 root=/dev/ram0 rw initrd=0x85000000,32M mem=120M video=dm64xxfb:format=non_stn:output=ntsc'
	
else
	echo "========== SLKE: Do version Upgrade  (Current configuration will be restored) =========="
	echo "kjarrah@evertz.com: To parse the configuration file..."
	./encoder_cfg_parser_vu.sh					# Parse /tmp/cfg_forward back into /mnt/flashdisk/vid_enc_cfg_720x480.txt
    rm -f /tmp/encoder_cfg_parser_vu.sh /tmp/encoder_cfg_parser_cp.sh
	chmod 666 /mnt/flashdisk/vid_enc_cfg_720x480.txt

    if [ ! -f $fw_setenv_file ]; then
		echo "kjarrah@evertz.com: To set fw environment..."
                mv /tmp/fw_setenv /ali/fw_setenv
                mv /tmp/fw_env.config /etc
                chmod 755 /ali/fw_setenv
	else
		rm -f /tmp/fw_setenv
		rm -f /tmp/fw_env.config
    fi

	echo "kjarrah@evertz.com: To switch to the non-standard mode..."
	/ali/fw_setenv bootargs 'setenv bootargs console=ttyS0,115200n8 root=/dev/ram0 rw initrd=0x85000000,32M mem=120M video=dm64xxfb:format=non_stn:output=ntsc'
fi
   
echo "setting capture image height according to current standard (PAL or NTSC)"
./set_ntsc_pal_height.sh h264 
   
rm -f /tmp/vid_enc_cfg_720x480.txt

rm_files	
echo "wr_img.sh success"
./reboot.sh &
exit 0
